# ******************************************************************************************************************
# ODLGen V0.1 2006 (c) A. Malti --- amalti+NOSPAM@gmail.com --- Copyright: This is released under the GPL V2.0
# This is an awk script to automatically generate the case statement for the output decode logic process of an FSM.
# *****************************************************************************************************************
# ***************    Invoke as follows: awk -v nsigs=xxx -f odlgen.awk input_file.csv   ***************************
# *****************************************************************************************************************
# nsigs represents the number of control signals in your FSM; So, xxx must be an integer.
# Please note that the .csv file should NOT have any quotes inside it. I use Oocalc (www.openoffice.org) to convert 
# the control signal table (which should have the state numbers as first column and name of the signals in the 
# first row) into a .csv file, then any editor to replace " with void (nothing, emptiness, nada ...).
# *****************************************************************************************************************

BEGIN{FS = ","; printf("case PRESENT_STATE is\n")}

/^state/{
split($0, ctrl_sigs_names, ",")
	}

/^/     {
printf("when S%s =>\n",$1)
i=2
while(i<=nsigs){
if(length($i)==1) printf("%s <= '%s';\n", ctrl_sigs_names[i], $i);
else printf("%s <= \"%s\";\n", ctrl_sigs_names[i], $i);
i++;
               }
	}

END{printf("end case;")}
